$release        = '7.2.6.52189'
$intver         = '7.2.6-52189'
$uninstver      = '7.2.52189'
$packageName    = 'zarafa-outlook-client'
$fileType       = 'msi'
$silentArgs     = '/qb /norestart REBOOT=ReallySuppress'
$packageSearch  = 'Zarafa Outlook Client*'
$foourl         = 'https://winpkg.foo.li/src/installer/zarafaclient-' + $intver + '.msi'
$title          = 'foo.li softwareverteilung'
$checksum       = 'E5BA15E23C7D43AF73BDA125DDFED08A83B13088'
$checksumType   = 'sha1'
$checksum64     = $checksum
$checksumType64 = $checksumType


function Show-BalloonTip {            
[cmdletbinding()]            
param(            
 [parameter(Mandatory=$true)]            
 [string]$Title,            
 [ValidateSet("Info","Warning","Error")]             
 [string]$MessageType = "Info",            
 [parameter(Mandatory=$true)]            
 [string]$Message,            
 [string]$Duration=10000            
)            

[system.Reflection.Assembly]::LoadWithPartialName('System.Windows.Forms') | Out-Null            
$balloon = New-Object System.Windows.Forms.NotifyIcon            
$path = Get-Process -id $pid | Select-Object -ExpandProperty Path            
$icon = [System.Drawing.Icon]::ExtractAssociatedIcon($path)            
$balloon.Icon = $icon            
$balloon.BalloonTipIcon = $MessageType            
$balloon.BalloonTipText = $Message            
$balloon.BalloonTipTitle = $Title            
$balloon.Visible = $true            
$balloon.ShowBalloonTip($Duration)  

}

# Check if the same version is already installed
#$key = Get-WmiObject -Class Win32_Product | Where-Object {$_.Name -match 'Zarafa Outlook Client'}
#if ($key -and ([version]$key.Version -ge $uninstver)) {
#  Write-Host "Zarafa Outlook Client Version" [version]$key.Version "bereits installiert!"
#  #Write-ChocolateySucces $packageName
#} else {
 try {
    $app = Get-ItemProperty -Path @('HKLM:\Software\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\*',
                                    'HKLM:\Software\Microsoft\Windows\CurrentVersion\Uninstall\*') `
            -ErrorAction:SilentlyContinue | Where-Object { $_.DisplayName -like $packageSearch }

    if ($app -and ([version]$app.DisplayVersion -ge [version]$uninstver)) {
        Write-Output $(
        'Zarafa Connector ' + $uninstver + ' or greater is already installed. ' +
        'No need to download and install again. Otherwise uninstall first.'
        )
    } else {
        Write-Host 'checking for supported Outlook version. this may take a moment...'
        if (get-wmiobject Win32_Product |where {$_.Name -like "*Outlook*" -and $_.Version -ge "15" -and $_.Vendor -eq "Microsoft Corporation"}) {
            Write-Output "Outlook 2013 (or higher) seems to be present. Use Z-Push, connector is not supported."
            throw $_.Exception
        }
    
        $strFileName="\\unxfsv001\software\nonfree\z\zarafa\zarafaclient-" + $intver + ".msi"
        If (Test-Path $strFileName){
            Write-Host "found Installer on Share..."
            $url = $strFileName
            $url64bit = $url
        } else {
            Write-Host "Downloading Release" $release "from foo.li..."
            (New-Object Net.WebClient).DownloadFile($foourl,$env:Temp +'\zarafaclient.msi')
            $url = $env:Temp +'\zarafaclient.msi'
            $url64bit = $url
        }    
        #close Outlook if it's running...
        #nicht im loop, sonst wird man vollgespammt
        $ProcessActive = Get-Process outlook -ErrorAction SilentlyContinue
        if (!($ProcessActive -eq $null)) {
            Show-BalloonTip -Title $title -MessageType Warning -Message 'Outlook bitte schliessen, damit der Zarafa Connector aktualisiert werden kann. In 20 Sekunden wird es automatisch beendet.'
            While (Get-Process Outlook -ErrorAction SilentlyContinue) {
                #For ($i = 0; $i -le 4; $i+=1) { 
                Write-Warning "Outlook is running"
                Write-Warning "waiting 20 seconds and then kill that thing"
                Start-Sleep -Seconds 20
                ps outlook -ErrorAction SilentlyContinue | kill -PassThru -Force 
                ps ZarafaUpdaterService -ErrorAction SilentlyContinue | kill -PassThru -Force 
                ps jmsoutlookaddrbookcomserver32 -ErrorAction SilentlyContinue | kill -PassThru -Force
                #if ($i -eq 4) { ps outlook -ErrorAction SilentlyContinue | kill -PassThru -Force }}
            }
        }
        Install-ChocolateyPackage $packageName $fileType $silentArgs $url $url64bit `
                                -checksum $checksum -checksumType $checksumType `
                                -checksum64 $checksum64 -checksumType64 $checksumType64
        Show-BalloonTip -Title $title -MessageType Info -Message 'Die Aktualisierung des Zarafa Outlook Clients ist fertiggestellt, Outlook kann nun wieder verwendet werden.'
        #delete downloaded file
        #if (Test-Path "$env:Temp +'\zarafaclient.msi'") {
        #    Remove-Item "$env:Temp +'\zarafaclient.msi'" #-Recurse
        #}
    }
 } catch {
   throw $_.Exception
 }